#!/usr/bin/python

# Display switch status for dome power control
#
# Copyright 2012 John Kielkopf


import sys,time

# The module needs to be in the python path.  So we'll add the
# current directory so we can find the dli module
sys.path.append('.')

# Import the DLI module -- must be in the same directory as this py file
import dli

# Switch settings

SWITCHIP="136.165.99.84"
USER="user"
PASSWORD="password"

# Open (connect) to the power switch, if the
# parameters are not passed it defaults to the
# IP address, user and password the switch is 
# set with from the factory.  Only changed items
# actually need to be passed.
switch=dli.powerswitch(hostname=SWITCHIP,userid=USER,password=PASSWORD)

# Verify the switch
if not switch.verify():
  print "Cannot talk to the switch"
  sys.exit(1)

# Print the current state of all the outlets
switch.printstatus()
  
