#!/usr/bin/python

# Retrieve status from the PWI server


import pycurl
import StringIO
from bs4 import BeautifulSoup
import re
import math

c = pycurl.Curl()
c.setopt(pycurl.URL, "http://192.168.10.90?cmd=getsystem")

b = StringIO.StringIO()
c.setopt(pycurl.WRITEFUNCTION, b.write)
c.setopt(pycurl.FOLLOWLOCATION, 1)
c.setopt(pycurl.MAXREDIRS, 5)
c.perform()
pwi_status = b.getvalue()

soup = BeautifulSoup(pwi_status, "lxml")


value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.azm_radian))
azm_radian_value = value[0]
azm_radian = float(azm_radian_value)
azm_degree = math.degrees(azm_radian)

value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.alt_radian))
alt_radian_value = value[0]
alt_radian = float(alt_radian_value)
alt_degree = math.degrees(alt_radian)

focuser1 = "True" in str(soup.focuser1.connected)

value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.focuser1.position))
focuser1_value = value[0]
focuser1_position = float(focuser1_value)


focuser2 = "True" in str(soup.focuser2.connected)

value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.focuser2.position))
focuser2_value = value[0]
focuser2_position = float(focuser2_value)


rotator1 = "True" in str(soup.rotator1.connected)
rotator1_moving = "True" in soup.rotator1.moving
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.rotator1.position))
rotator1_value = value[0]
rotator1_rotation = float(rotator1_value)


rotator2 = "True" in str(soup.rotator2.connected)
rotator2_moving = "True" in soup.rotator2.moving
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.rotator2.position))
rotator2_value = value[0]
rotator2_rotation = float(rotator2_value)


mount = "True" in str(soup.mount.connected)
on_target = "True" in str(soup.mount.on_target)
moving = "True" in str(soup.mount.moving)
tracking = "True" in str(soup.mount.tracking)

value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.ra))
ra = float(value[0]) + float(value[1])/60. + float(value[2])/3600.
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.dec))

dec = math.fabs(float(value[0])) + float(value[1])/60. + float(value[2])/3600.
dec = math.copysign(dec, float(value[0]))
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.ra_2000))
ra_2000 = float(value[1]) + float(value[2])/60. + float(value[3])/3600.
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.dec_2000))
dec_2000 = math.fabs(float(value[1])) + float(value[2])/60. + float(value[3])/3600.
dec_2000 = math.copysign(dec_2000,float(value[1]))
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.ra_target))
ra_target = float(value[0]) + float(value[1])/60. + float(value[2])/3600.
value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.mount.dec_target))
dec_target = abs(float(value[0])) + float(value[1])/60. + float(value[2])/3600.
dec_target = math.copysign(dec_target, float(value[0]))
m3 = "True" in str(soup.m3.connected)
if m3 :
  value = re.findall(r"[-+]?\d*\.*\d+|\d+", str(soup.m3.position_rotate))
  if len(value) == 1:
    m3_rotate_value = value[0]
    m3_rotation = float(m3_rotate_value)
  else:
    m3_rotation = 0.        
  value = re.findall(r"[-+]?\d*\.*\d+\d+", str(soup.m3.position_tilt))
  if len(value) == 1:
    m3_tilt_value = value[0]
    m3_tilt = float(m3_tilt_value)
  else:
    m3_tilt = 45. 
else:
  m3_rotation = 0.
  m3_tilt = 45.
  
fans = "True" in str(soup.fans.on)

fh = open('/usr/local/observatory/status/telcoords', 'w+')
fh.write("%4.6f %4.6f \n" % (ra, dec))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telcoords2000', 'w+')
fh.write("%4.6f %4.6f \n" % (ra_2000, dec_2000))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/teltarget', 'w+')
fh.write("%4.6f %4.6f \n" % (ra_target, dec_target))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/teltarget', 'w+')
fh.write("%4.6f %4.6f \n" % (ra_target, dec_target))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telaltaz', 'w+')
fh.write("%4.6f %4.6f \n" % (alt_degree, azm_degree))
fh.flush()  
fh.close()


fh = open('/usr/local/observatory/status/telrotation', 'w+')
fh.write("%4.2f %4.2f \n" % (rotator1_rotation, rotator2_rotation))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telrotator_status', 'w+')
fh.write("%s %s \n" % (rotator1, rotator2))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telfocus', 'w+')
fh.write("%4.2f %4.2f \n" % (focuser1_position, focuser2_position))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telrotator_status', 'w+')
fh.write("%s %s \n" % (focuser1, focuser2))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telm3', 'w+')
fh.write("%4.2f %4.2f \n" % (m3_rotation, m3_tilt))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telm3_status', 'w+')
fh.write("%s \n" % (m3,))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/teltracking_status', 'w+')
fh.write("%s \n" % (tracking,))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telmoving_status', 'w+')
fh.write("%s \n" % (moving,))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telontarget_status', 'w+')
fh.write("%s \n" % (on_target,))
fh.flush()  
fh.close()

fh = open('/usr/local/observatory/status/telfans_status', 'w+')
fh.write("%s \n" % (fans,))
fh.flush()  
fh.close()


exit()